<?php

//////////////////////////////////////////////////////////////////////////
//
// Class to query categories
//
//////////////////////////////////////////////////////////////////////////

require_once __DIR__."/apicall.php";

class fuEbayCategoriesApiCall extends fuEbayApiCall
{  
  public $catId;
  public $getChildren = 1;
  public $getSiblings = 0;
  public $getParents = 0;

  function __construct(int $catId = 0) 
  {
    parent::__construct();
    $this->catId = $catId;
    $this->callCacheExpiry = FUBABY_EBAY_CALLCACHEEXPIRYCATEGORIES;
  }

  protected function constructRequest()
  {
    $queryParams = array(
      "id" => intval($this->catId),
      "getChildren" => intval($this->getChildren),
      "getSiblings" => intval($this->getSiblings),
      "getParents" => intval($this->getParents)
    );

    $this->requestUri = $this->getEndpoint() . "categories?" . http_build_query($queryParams);
    parent::constructRequest();
  }

  protected function createListingGrid($resp)
  {
    if (is_null($resp)) return null;
    $this->result = $resp;
  }

  protected function createDeferredLoadingStub()
  {
    error_log(FUBABY_EBAY_PLUGIN_TITLE . ": fuEbayCategoriesApiCall.createDeferredLoadingStub() Unsupported function");
  }
}
