<?php

//////////////////////////////////////////////////////////////////////////
//
// Class to query sub info
//
//////////////////////////////////////////////////////////////////////////

require_once __DIR__."/apicall.php";

class fuEbaySubInfoApiCall extends fuEbayApiCall
{  
  
  function __construct() 
  {
    parent::__construct();
  }

  protected function constructRequest()
  {
    $this->requestUri = $this->getEndpoint() . "subinfo?id=1";
    parent::constructRequest();
  }

  protected function createListingGrid($resp)
  {
    global $fu_ebay_subscription_states;
    if (is_null($resp)) return "";

    $subInfo = $resp->data;
    $this->result .= "<p>";
    $this->result .= sprintf(
      /* translators: %s: status */
      __("Subscription Status: %s", "fast-ebay-listings"),
      $fu_ebay_subscription_states[$subInfo->state]);

    if ($subInfo->state == fuEbaySubStates::Unsubscribed)
    {
      $subscriptionKey = get_option('fubaby_ebaySubscriptionKey');
      if (!empty($subscriptionKey))
        $this->result .= " - <span style=\"color: red;\">" . __("Subscription Key / Domain not recognized", "fast-ebay-listings") . "</span>";

      $this->result .=  "<br/><a href=\"" . FUBABY_EBAY_PLUGIN_WEBSITE . "fast-ebay-listings-premium-subscription/\" target=\"_blank\">";
      $this->result .=  __("Click here for more information on premium subscription benefits and pricing.", "fast-ebay-listings");
      $this->result .=  "</a>";
    }
    else
    {
      $expiry = date_i18n("F j, Y", strtotime($subInfo->expiry));
      if ($subInfo->daysLeft > 0)
      {
        $this->result .= " - ";
        $this->result .= sprintf(
          /* translators: %s: expired date */
          __("expires: %s", "fast-ebay-listings"),
          $expiry);
      }
      else
      {
        $this->result .= " - <span style=\"color: red;\">";
        $this->result .= sprintf(
          /* translators: %s: expired date */
          __("expired: %s", "fast-ebay-listings"),
          $expiry);
        $this->result .= "</span>";
      }
    } 
    $this->result .= "</p>";
  }

  protected function createDeferredLoadingStub()
  {
    error_log(FUBABY_EBAY_PLUGIN_TITLE . ": fuEbaySubInfoApiCall.createDeferredLoadingStub() Unsupported function");
  }
}
