<?php

require_once __DIR__."/../constants.php";
require_once __DIR__."/../apicall_categories.php";


////////////////////////////////////////////////////////////////////////////////////////////////////////
// Add category choose UI to footer.
function fu_ebay_admincatchooser() 
{
  echo '<div id="fu_ebay_cat_popup_overlay">
  <div id="fu_ebay_cat_popup_content">
  <h2>' . FUBABY_EBAY_PLUGIN_TITLE . __(" - eBay Category Chooser", "fast-ebay-listings") . '</h2>
  <button id="fu_ebay_cat_popup_cancel" class="fu_ebay_cat_popup_button">X</button>';

  for ($i=1; $i<=FUBABY_EBAY_CATEGORYMAXDEPTH; ++$i)
  {
    echo '<div class="fu_ebay_cat_popup_catlist_container">';
    echo '<select class="fu_ebay_cat_popup_catlist" id="cat_list_l'.$i.'" name="cat_list_l'.$i.'" cat_depth="'.$i.'" size="12"></select>';
    echo '<div class="fu_ebay_cat_popup_catlist_loading" id="cat_list_loading_l'.$i.'">' . __("Loading...", "fast-ebay-listings") . '</div>';
    echo '</div>';
  }

  echo '
  <div id="fu_ebay_cat_popup_chosenrow">
    <button id="fu_ebay_cat_popup_clearchosen" class="fu_ebay_cat_popup_button">' . __("Clear selection/Use default", "fast-ebay-listings") . '</button>
    <input type="text" id="fu_ebay_cat_popup_chosen" name="fu_ebay_cat_popup_chosen" readonly>
    <input type="hidden" id="fu_ebay_cat_popup_chosencatid" name="fu_ebay_cat_popup_chosencatid">
    <button id="fu_ebay_cat_popup_close" class="fu_ebay_cat_popup_button">' . __("Use category", "fast-ebay-listings") . '</button>
  </div>
  </div></div>
  <script>
  var fu_ebay_adminurl = "' . admin_url('admin-ajax.php') . '";
  var fu_ebay_catnonce = "' . wp_create_nonce("fu_cat_chooser") . '";
  </script>
  ';
}
add_action('admin_footer', 'fu_ebay_admincatchooser');

// AJAX entry function for category chooser
function fu_ebay_load_categories() 
{
  @ini_set( 'display_errors', 1 );
  if (!check_ajax_referer('fu_cat_chooser', 'nonce', false)) 
  {
    $this->errorLog('Nonce check failed');
    die;
  }

  $apicall = new fuEbayCategoriesApiCall(intval($_POST['fu_ebay_catid']));
  $apicall->getChildren = isset($_POST['fu_ebay_getChildren']) ? intval($_POST['fu_ebay_getChildren']) : 0;
  $apicall->getSiblings = isset($_POST['fu_ebay_getSiblings']) ? intval($_POST['fu_ebay_getSiblings']) : 0;
  $apicall->getParents = isset($_POST['fu_ebay_getParents']) ? intval($_POST['fu_ebay_getParents']) : 0;
  $resp = $apicall->call(true);
  if (!is_null($resp) && isset($resp->data))
    echo json_encode($resp->data);
  else
    echo json_encode(
      sprintf(
        /* translators: %d: category ID */
        __("%d - Category ID query failed! Possibly invalid or out of date.", "fast-ebay-listings"),
        intval($_POST['fu_ebay_catid'])));
  die();
}

add_action( 'wp_ajax_fu_ebay_load_categories', 'fu_ebay_load_categories' );
add_action( 'wp_ajax_nopriv_fu_ebay_load_categories', 'fu_ebay_load_categories' );