<?php

define("FUBABY_EBAY_PLUGIN_TITLE", __("Fast eBay Listings", "fast-ebay-listings"));
define("FUBABY_EBAY_PLUGIN_VER", "2.7.6");
define("FUBABY_EBAY_PLUGIN_WEBSITE", "https://www.fubaby.com/wordpress-plugins/fast-ebay-listings/");
define("FUBABY_EBAY_META_KEY_PREFIX", "ebay-");
define("FUBABY_EBAY_CALLCACHEEXPIRY", 360); // minutes (6 hrs)
define("FUBABY_EBAY_CALLCACHEEXPIRYCATEGORIES", 2880); // minutes (2 days)
define("FUBABY_EBAY_CALLCACHEEXPIRYFEEDBACK", 1440); // minutes (1 day)
define("FUBABY_EBAY_CALLCACHEEXPIRYDYNSEARCH", 2880); // minutes (2 days)
define("FUBABY_EBAY_GOTOQUERYPARAM", "goto_ebay");
define("FUBABY_EBAY_BINLOGOIMG", "/images/bin_15x54.gif");
define("FUBABY_EBAY_BINBOLOGOIMG", "/images/logoBinBo_70x20.gif");
define("FUBABY_EBAY_CATEGORYMAXDEPTH", 4);
define("FUBABY_EBAY_MAXCOLUMNS", 8);

// Common bots/crawler useragents. Avoid making an eBay call for these to keep page loads fast and not overload eBay servers.
$fu_ebay_bot_useragents = array('google','bot','crawl','lighthouse','insights','spider','slurp','baidu','bing','msn','teoma','yandex','java','wget','curl','commons-httpclient','python-urllib','libwww','httpunit','nutch','biglotron','convera','gigablast','archive','webmon','httrack','grub','netresearchserver','speedy','fluffy','bibnum','findlink','panscient','ioi','ips-agent','yanga','voyager','cyberpatrol','postrank','page2rss','linkdex','ezooms','heritrix','findthatfile','aboundex','summify','ec2linkfinder','facebook','slack','instagram','pinterest','reddit','twitter','whatsapp','yeti','retrevopageanalyzer','sogou','wotbox','ichiro','drupact','coccoc','integromedb','siteexplorer','proximic','changedetection','wesee','scrape','scaper','g00g1e','binlar','indexer','megaindex','ltx71','bubing','qwantify','lipperhey','y!j-asr','addthis');

$ebay_globalid_descriptions = array(
  'EBAY-AT' => "Austria",
  'EBAY-AU' => "Australia",
  'EBAY-BE' => "Belgium",
  'EBAY-CA' => "Canada",
  'EBAY-CH' => "Switzerland ",
  'EBAY-DE' => "Germany",
  'EBAY-ES' => "Spain",
  'EBAY-FR' => "France",
  'EBAY-GB' => "Great Britain",
  'EBAY-HK' => "Hong Kong",
  'EBAY-IE' => "Ireland",
  'EBAY-IN' => "India",
  'EBAY-IT' => "Italy",
  'EBAY-MY' => "Malaysia",
  'EBAY-NL' => "Netherlands",
  'EBAY-PH' => "Philippines ",
  'EBAY-PL' => "Poland",
  'EBAY-SG' => "Singapore",
  'EBAY-TH' => "Thailand",
  'EBAY-TW' => "Taiwan",
  'EBAY-VN' => "Vietnam",
  'EBAY-US' => "United States",
);

$ebay_globalid_siteurls = array(
  'EBAY-AT' => 'https://www.ebay.at/',
  'EBAY-AU' => 'https://www.ebay.com.au/',
  'EBAY-BE' => 'https://www.ebay.be/',
  'EBAY-CA' => 'https://www.ebay.ca/',
  'EBAY-CH' => 'https://www.ebay.ch/',
  'EBAY-DE' => 'https://www.ebay.de/',
  'EBAY-ES' => 'https://www.ebay.es/',
  'EBAY-FR' => 'https://www.ebay.fr/',
  'EBAY-GB' => 'https://www.ebay.co.uk/',
  'EBAY-HK' => 'https://www.ebay.com.hk/',
  'EBAY-IE' => 'https://www.ebay.ie/',
  'EBAY-IN' => 'https://www.ebay.in/',
  'EBAY-IT' => 'https://www.ebay.it/',
  'EBAY-MY' => 'https://www.ebay.com.my/',
  'EBAY-NL' => 'https://www.ebay.nl/',
  'EBAY-PH' => 'https://www.ebay.ph/',
  'EBAY-PL' => 'https://www.ebay.pl/',
  'EBAY-SG' => 'https://www.ebay.com.sg/',
  'EBAY-TH' => 'https://info.ebay.co.th/',
  'EBAY-TW' => 'https://www.ebay.com.tw/',
  'EBAY-VN' => 'https://www.ebay.vn/',
  'EBAY-US' => 'https://www.ebay.com/',
);

$ebay_globalid_logos = array(
  'EBAY-AT' => "/DE/Right%20Now%20108x45.gif",
  'EBAY-AU' => "/US/Right%20Now%20108x45.gif",
  'EBAY-BE' => "/FR/Right%20Now%20108x45.gif",
  'EBAY-CA' => "/US/Right%20Now%20108x45.gif",
  'EBAY-CH' => "/DE/Right%20Now%20108x45.gif",
  'EBAY-DE' => "/DE/Right%20Now%20108x45.gif",
  'EBAY-CA' => "/FR/Right%20Now%20108x45.gif",
  'EBAY-ES' => "/ES/eBay_ahora_mismo_en-_vert.png",
  'EBAY-FR' => "/FR/Right%20Now%20108x45.gif",
  'EBAY-GB' => "/US/Right%20Now%20108x45.gif",
  'EBAY-HK' => "/US/Right%20Now%20108x45.gif",
  'EBAY-IE' => "/US/Right%20Now%20108x45.gif",
  'EBAY-IN' => "/US/Right%20Now%20108x45.gif",
  'EBAY-IT' => "/IT/Right%20Now%20108x45.gif",
  'EBAY-MY' => "/US/Right%20Now%20108x45.gif",
  'EBAY-NL' => "/NL/Right%20Now%20108x45.gif",
  'EBAY-PH' => "/SU/Right%20Now%20108x45.gif",
  'EBAY-PL' => "/US/Right%20Now%20108x45.gif",
  'EBAY-SG' => "/US/Right%20Now%20108x45.gif",
  'EBAY-TH' => '/US/Right%20Now%20108x45.gif',
  'EBAY-TW' => '/US/Right%20Now%20108x45.gif',
  'EBAY-VN' => '/US/Right%20Now%20108x45.gif',
  'EBAY-US' => "/US/Right%20Now%20108x45.gif",
);

$ebay_globalid_currencies = array(
  'EBAY-AT' => "&euro;",
  'EBAY-AU' => "\$",
  'EBAY-BE' => "&euro;",
  'EBAY-CA' => "\$",
  'EBAY-CH' => "CHF ",
  'EBAY-DE' => "&euro;",
  'EBAY-CA' => "\$",
  'EBAY-ES' => "&euro;",
  'EBAY-FR' => "&euro;",
  'EBAY-GB' => "&pound;",
  'EBAY-HK' => "\$;",
  'EBAY-IE' => "&euro;",
  'EBAY-IN' => "Rs. ",
  'EBAY-IT' => "&euro;",
  'EBAY-MY' => "RM ;",
  'EBAY-NL' => "&euro;",
  'EBAY-PH' => "PHP ",
  'EBAY-PL' => "&euro;",
  'EBAY-SG' => "S\$",
  'EBAY-TH' => '&#3647;',
  'EBAY-TW' => 'NT\$',
  'EBAY-VN' => '&#8363;',
  'EBAY-US' => "\$",
);

$ebay_globalid_currency_codes = array(
  'EBAY-AT' => "EUR",
  'EBAY-AU' => "AUD",
  'EBAY-BE' => "EUR",
  'EBAY-CA' => "CAD",
  'EBAY-CH' => "CHF ",
  'EBAY-DE' => "EUR",
  'EBAY-ES' => "EUR",
  'EBAY-FR' => "EUR",
  'EBAY-GB' => "GBP",
  'EBAY-HK' => "HKD",
  'EBAY-IE' => "EUR",
  'EBAY-IN' => "INR",
  'EBAY-IT' => "EUR",
  'EBAY-MY' => "MYR",
  'EBAY-NL' => "EUR",
  'EBAY-PH' => "PHP ",
  'EBAY-PL' => "EUR",
  'EBAY-SG' => "SGB",
  'EBAY-TH' => 'THB',
  'EBAY-TW' => 'TWD',
  'EBAY-VN' => 'VND',
  'EBAY-US' => "USD",
);

$ebay_globalid_hastaxonomy = array(
  'EBAY-AT' => true,
  'EBAY-AU' => true,
  'EBAY-BE' => true,
  'EBAY-CA' => true,
  'EBAY-CH' => true,
  'EBAY-DE' => true,
  'EBAY-ES' => true,
  'EBAY-FR' => true,
  'EBAY-GB' => true,
  'EBAY-HK' => true,
  'EBAY-IE' => true,
  'EBAY-IN' => true,
  'EBAY-IT' => true,
  'EBAY-MY' => true,
  'EBAY-NL' => true,
  'EBAY-PH' => true,
  'EBAY-PL' => true,
  'EBAY-SG' => true,
  'EBAY-TH' => false,
  'EBAY-TW' => false,
  'EBAY-VN' => false,
  'EBAY-US' => true,
);

class fuEbayColourStyle
{
  const Default = "Default";
  const White = "White";
  const Black = "Black";
}

$ebay_colour_options = array(
  fuEbayColourStyle::Default => __("Site default", "fast-ebay-listings"),
  fuEbayColourStyle::White => __("Black text on white background", "fast-ebay-listings"),
  fuEbayColourStyle::Black => __("White text on black background", "fast-ebay-listings"),
);

$ebay_colour_class = array(
  fuEbayColourStyle::Default => "",
  fuEbayColourStyle::White => "fu_ebay_blackonwhite",
  fuEbayColourStyle::Black => "fu_ebay_whiteonblack",
);

class fuEbaySortOrder 
{
  const BestMatch = "BestMatch";
  const CurrentPriceHighest = "CurrentPriceHighest";
  const DistanceNearest = "DistanceNearest";
  const EndTimeSoonest = "EndTimeSoonest";
  const PricePlusShippingHighest = "PricePlusShippingHighest";
  const PricePlusShippingLowest = "PricePlusShippingLowest";
  const StartTimeNewest = "StartTimeNewest";
}

$ebay_sort_order = array(
  fuEbaySortOrder::BestMatch => __("Best Match", "fast-ebay-listings"),
  fuEbaySortOrder::CurrentPriceHighest => __("Highest Price First", "fast-ebay-listings"),
  fuEbaySortOrder::DistanceNearest => __("Nearest First", "fast-ebay-listings"),
  fuEbaySortOrder::EndTimeSoonest => __("Ending Soonest", "fast-ebay-listings"),
  fuEbaySortOrder::PricePlusShippingHighest => __("Highest Price + P&P First", "fast-ebay-listings"),
  fuEbaySortOrder::PricePlusShippingLowest => __("Lowest Price + P&P First", "fast-ebay-listings"),
  fuEbaySortOrder::StartTimeNewest => __("Newest First", "fast-ebay-listings"),
);

$ebay_map_sort_browseapi = array(
  fuEbaySortOrder::BestMatch => "",
  fuEbaySortOrder::CurrentPriceHighest => "-price",
  fuEbaySortOrder::DistanceNearest => "distance",
  fuEbaySortOrder::EndTimeSoonest => "endingSoonest",
  fuEbaySortOrder::PricePlusShippingHighest => "-price",
  fuEbaySortOrder::PricePlusShippingLowest => "price",
  fuEbaySortOrder::StartTimeNewest => "newlyListed",
);

class fuEbayArrangement
{
  const TitleBelow = 0;
  const TitleTop = 1;
  const ImageLeft = 2;
}

class fuEbaySlideShowStyle
{
  const None = "None";
  const Manual = "Manual";
  const Auto = "Auto";
}

$fu_ebay_slideshow_styles = array(
  fuEbaySlideShowStyle::None => __("None", "fast-ebay-listings"),
  fuEbaySlideShowStyle::Manual => __("Manual", "fast-ebay-listings"),
  fuEbaySlideShowStyle::Auto => __("Auto", "fast-ebay-listings"),
);


class fuEbaySubStates
{
  const Unsubscribed = "Unsubscribed";
  const Expired = "Expired";
  const GracePeriod = "Grace period";
  const Subscriber = "Subscriber";
}

$fu_ebay_subscription_states = array(
  fuEbaySubStates::Unsubscribed => __("Unsubscribed", "fast-ebay-listings"),
  fuEbaySubStates::Expired => __("Expired", "fast-ebay-listings"),
  fuEbaySubStates::GracePeriod => __("Grace Period", "fast-ebay-listings"),
  fuEbaySubStates::Subscriber => __("Subscriber", "fast-ebay-listings"),
);

class fuEbayDeferedLoading
{
  const Always = "Always";
  const NotCached = "NotCached";
  const Never = "Never";
}

$fu_deferred_loading_options = array(
  fuEbayDeferedLoading::Always => __("Always", "fast-ebay-listings"),
  fuEbayDeferedLoading::NotCached => __("When not cached", "fast-ebay-listings"),
  fuEbayDeferedLoading::Never => __("Never", "fast-ebay-listings")
);

class fuEbayBuyingOptions
{
  const FixedPrice = "FIXED_PRICE";
  const Auction = "AUCTION";
  const BestOffer = "BEST_OFFER";
  const ClassifiedAd = "CLASSIFIED_AD";
}

$fu_buying_options = array(
  fuEbayBuyingOptions::FixedPrice => __("Fixed Price", "fast-ebay-listings"),
  fuEbayBuyingOptions::Auction => __("Auction", "fast-ebay-listings"),
  fuEbayBuyingOptions::BestOffer => __("Best Offer", "fast-ebay-listings")
);

class fuEbaySellerType
{
  const Any = "BUSINESS|INDIVIDUAL";
  const Business = "BUSINESS";
  const Individual = "INDIVIDUAL";
}

$fu_seller_type_options = array(
  fuEbaySellerType::Any => __("Any", "fast-ebay-listings"),
  fuEbaySellerType::Business => __("Business", "fast-ebay-listings"),
  fuEbaySellerType::Individual => __("Individual", "fast-ebay-listings")
);

$fu_feedback_rating_details = array(
  "ItemAsDescribed" => __("Item as described", "fast-ebay-listings"),
  "Communication" => __("Communication", "fast-ebay-listings"),
  "ShippingTime" => __("Despatch time", "fast-ebay-listings"),
  "ShippingAndHandlingCharges" => __("Postage", "fast-ebay-listings")
);

class fuEbayDisplayFields
{
  const Title = "TITLE";
  const ShortDesc = "SHORTDESC";
  const Image = "IMAGE";
  const Price = "PRICE";
  const EndTime = "ENDTIME";
  const Feedback = "FEEDBACK";
  const Location = "LOCATION";
  const Seller = "SELLER";
  const Store = "STORE";
  const Condition = "CONDITION";
  const EbayLogo = "EBAYLOGO";
  const VisitLink = "VISITLINK";
  
  const ListingDefault = [
    fuEbayDisplayFields::Title, 
    fuEbayDisplayFields::Image, 
    fuEbayDisplayFields::Price, 
    fuEbayDisplayFields::EndTime, 
    fuEbayDisplayFields::Store, 
    fuEbayDisplayFields::VisitLink
  ];
  const ItemDefault = [
    fuEbayDisplayFields::Title, 
    fuEbayDisplayFields::Image, 
    fuEbayDisplayFields::Price, 
    fuEbayDisplayFields::EndTime, 
    fuEbayDisplayFields::Store, 
    fuEbayDisplayFields::Feedback, 
    fuEbayDisplayFields::Location, 
    fuEbayDisplayFields::VisitLink
  ];
}

$fu_ebay_listing_displayfields = array(
  fuEbayDisplayFields::Title => __("Title", "fast-ebay-listings"),
  fuEbayDisplayFields::ShortDesc => __("Short Description", "fast-ebay-listings"),
  fuEbayDisplayFields::Image => __("Image", "fast-ebay-listings"),
  fuEbayDisplayFields::Price => __("Price", "fast-ebay-listings"),
  fuEbayDisplayFields::EndTime => __("End Time", "fast-ebay-listings"),
  fuEbayDisplayFields::Feedback => __("Feedback", "fast-ebay-listings"),
  fuEbayDisplayFields::Location => __("Location", "fast-ebay-listings"),
  fuEbayDisplayFields::Seller => __("Seller", "fast-ebay-listings"),
  fuEbayDisplayFields::Store => __("Store", "fast-ebay-listings"),
  fuEbayDisplayFields::Condition => __("Condition", "fast-ebay-listings"),
  fuEbayDisplayFields::VisitLink => __("Link to eBay", "fast-ebay-listings"),
);