<?php
/*
 * Plugin Name: Fast eBay Listings
 * Plugin URI: http://www.fubaby.com/wordpress-plugins/fast-ebay-listings/
 * Description: Display eBay auctions on your site, through the use of blocks, shortcodes and widgets. 
 * Version: 2.7.6
 * Requires at least: 5.0
 * Requires PHP: 7.2
 * Author: Arthur Yarwood
 * Author URI: http://www.fubaby.com
 * Text Domain: fast-ebay-listings
 * License: GPL2
 * License URI: https://www.gnu.org/licenses/gpl-2.0.html
 */

/*
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */

require_once __DIR__ . "/constants.php";
require_once __DIR__ . "/admin.php";
require_once __DIR__ . "/cats/cat_chooser.php";
require_once __DIR__ . "/utilities.php";
require_once __DIR__ . "/listing.php";
require_once __DIR__ . "/shortcodes.php";
require_once __DIR__ . "/widget_ebay_search.php";
require_once __DIR__ . "/shortcode-item.php";
require_once __DIR__ . "/shortcode-feedback.php";
require_once __DIR__ . "/shortcode-rss.php";
require_once __DIR__ . "/shortcode-search.php";
require_once __DIR__ . "/blocks/feedback/feedback.php";
require_once __DIR__ . "/blocks/item/item.php";
require_once __DIR__ . "/blocks/rssfeed/rssfeed.php";
require_once __DIR__ . "/blocks/search/search.php";


////////////////////////////////////////////////////////////////////////////////////////////////////////
// Add settings link on WP plugin page

add_filter('plugin_action_links_' . plugin_basename(__FILE__), 'fu_ebay_settings_link');
function fu_ebay_settings_link( $actions ) 
{
  $mylinks = array(
    '<a href="' . admin_url( 'options-general.php?page=fast-ebay-listings' ) . '">' . __("Settings", "fast-ebay-listings") .'</a>',
  );
  $actions = array_merge( $actions, $mylinks );
	return $actions;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Handle goto_ebay redirections
function fu_ebay_init()
{
  if (isset($_REQUEST[FUBABY_EBAY_GOTOQUERYPARAM]) && !empty($_REQUEST[FUBABY_EBAY_GOTOQUERYPARAM]))
  {      
    $gotoUrl = $_REQUEST[FUBABY_EBAY_GOTOQUERYPARAM]; /* Get the "encrypted" url passed from the affiliate link */
    $gotoUrl = base64_decode($gotoUrl);
    header("Cache-Control: no-cache, must-revalidate");
    header("X-Robots-Tag: noindex, nofollow");
    header("Location: $gotoUrl", TRUE, 301);   /* Redirect browser to the new address */
    exit;
  }
}
add_action('init', 'fu_ebay_init');


////////////////////////////////////////////////////////////////////////////////////////////////////////
// Remove options on uninstall.

register_uninstall_hook(__FILE__, 'fu_ebay_uninstall');

?>
