
(function() {
	tinymce.PluginManager.add('ebay_feedback', function( editor, url ) {
		var sh_tag = 'ebay_feedback';

		//helper functions 
		function getAttr(s, n) {
			r = new RegExp(n + '=\"([^\"]*)\"', 'g').exec(s);
			if (!r) r = new RegExp(n + '=(.+?)([\\s$])', 'g').exec(s);
			return r ?  window.decodeURIComponent(r[1]) : '';
		};

		function replaceShortcodes( content ) {
			return content.replace( /\[(fu_ebay_feedback|ebay_feedback)([^\]]*)\]/g, function(all,tag,attr) {
        var placeholder = url + '/images/ebayfeedbackpanel.jpg';
        attr = window.encodeURIComponent( attr );
  
        html = '<img src="' + placeholder + '" class="mceItem wp-' + sh_tag + '" ';
        html += 'title="' + editor.getLang("extrastrings.dblClicktoEdit") + '" ';
        html += 'data-sh-attr="' + attr + '" data-mce-resize="false" data-mce-placeholder="1" />';
        return html;
			});
		}

		function restoreShortcodes( content ) {
			return content.replace( /(?:<p(?: [^>]+)?>)*(<img [^>]+>)(?:<\/p>)*/g, function( match, image ) {
				if (!getAttr( image, 'class' ).includes('wp-' + sh_tag)) return match;
				var data = getAttr( image, 'data-sh-attr' );

				if ( data ) {
					return '<p>[' + sh_tag + data + ']</p>';
				}
				return match;
			});
		}

		//add popup
		editor.addCommand('ebay_feedback_popup', function(ui, v) {
			//setup defaults
			var seller = v.seller ? v.seller : '';
			var limit = v.limit ? v.limit : 10;
			var customid = v.customid ? v.customid : '';
			
			editor.windowManager.open( {
				title: editor.getLang('extrastrings.felFeedback'),
				body: [		 
          {
            type: 'textbox',
            name: 'seller',
            label: editor.getLang('extrastrings.sellerLabel'),
            value: seller,
            placeholder: fuScriptShortcode.ebayDefSeller,
            tooltip: editor.getLang('extrastrings.sellerFeedbackToolTip')
          },
          {
            type: 'textbox',
            subtype: 'number',
            name: 'limit',
            label: editor.getLang('extrastrings.feedbackLimitLabel'),
            value: limit,
            tooltip: editor.getLang('extrastrings.feedbackLimitToolTip'),
            maxWidth: 100,
            maxLength: 4,
          },					   				
          {
            type: 'textbox',
            name: 'customid',
            label: editor.getLang('extrastrings.customIdLabel'),
            value: customid,
            placeholder: fuScriptShortcode.ebayDefCustomID,
            tooltip: editor.getLang('extrastrings.customIdToolTip'),
            maxWidth: 300,
          },	        
				],
				onsubmit: function( e ) {
					var shortcode_str = '[' + sh_tag;
					// check for seller
					if (typeof e.data.seller != 'undefined' && e.data.seller.length)
						shortcode_str += ' seller="' + e.data.seller + '"';
					// check for limit
					if (typeof e.data.limit != 'undefined' && e.data.limit.length)
						shortcode_str += ' limit="' + e.data.limit + '"';
					// check for customid
					if (typeof e.data.customid != 'undefined' && e.data.customid.length)
						shortcode_str += ' customid="' + e.data.customid + '"';

					//add panel content
					shortcode_str += ']';
					//insert shortcode to tinymce
					editor.insertContent( shortcode_str);
				}
			});
	  });

		//replace from shortcode to an image placeholder
		editor.on('BeforeSetcontent', function(event){ 
			event.content = replaceShortcodes( event.content );
		});

		//replace from image placeholder to shortcode
		editor.on('GetContent', function(event){
			event.content = restoreShortcodes(event.content);
		});

		//open popup on placeholder double click
		editor.on('DblClick',function(e) {
			var cls  = e.target.className.indexOf('wp-' + sh_tag);
			if ( e.target.nodeName == 'IMG' && e.target.className.indexOf('wp-' + sh_tag) > -1 ) {
				var title = e.target.attributes['data-sh-attr'].value;
				title = window.decodeURIComponent(title);
				//console.log(title);
				editor.execCommand('ebay_feedback_popup','',{
					seller : getAttr(title,'seller'),
					limit : getAttr(title,'limit'),
					customid : getAttr(title,'customid'),
				});
			}
		});
	});
})();