(function() {
	tinymce.PluginManager.add('ebay_rss', function( editor, url ) {
		var sh_tag = 'ebay_rss';
		var stubId = "ebay_rss";

		//helper functions 
		function getAttr(s, n) {
			r = new RegExp(n + '=\"([^\"]*)\"', 'g').exec(s);
			if (!r) r = new RegExp(n + '=(.+?)([\\s$])', 'g').exec(s);
			return r ?  window.decodeURIComponent(r[1]) : '';
		};

		function jsonEnc(str) {
			var out = JSON.stringify(str);
			return out.replace(/^"(.+(?="$))"$/, '$1');
		}

		function html(dat, con) {
			var placeholder = url + '/images/ebayrsspanel.jpg';
			data = window.encodeURIComponent( dat );
			content = window.encodeURIComponent( con );
			var html = '<img src="' + placeholder + '" class="mceItem wp-' + sh_tag + '" ';
      html += 'title="' + editor.getLang("extrastrings.dblClicktoEdit") + '" ';
      html += 'data-sh-attr="' + data + '" data-sh-content="'+ con+'" data-mce-resize="false" data-mce-placeholder="1" />';
			return html;
		}

		function replaceShortcodes( content ) {
			return content.replace( /\[(fu_ebay_rss|ebay_rss)([^\]]*)\]([^\]]*)\[\/(fu_ebay_rss|ebay_rss)\]/g, function( all,tag,attr,con) {
        var placeholder = url + '/images/ebayrsspanel.jpg';
        attr = window.encodeURIComponent( attr );
        content = window.encodeURIComponent( con );
        var html = '<img src="' + placeholder + '" class="mceItem wp-' + sh_tag + '" ';
        html += 'title="' + editor.getLang("extrastrings.dblClicktoEdit") + '" ';
        html += 'data-sh-attr="' + attr + '" data-sh-content="'+ con+'" data-mce-resize="false" data-mce-placeholder="1" />';
        return html;
      });
		}

		function restoreShortcodes( content ) {
			return content.replace( /(?:<p(?: [^>]+)?>)*(<img [^>]+>)(?:<\/p>)*/g, function( match, image ) {
				if (!getAttr( image, 'class' ).includes('wp-' + sh_tag)) return match;
				var data = getAttr( image, 'data-sh-attr' );
				var con = getAttr( image, 'data-sh-content' );

				if ( data ) {
					return '<p>[' + sh_tag + data + ']' + con + '[/'+sh_tag+']</p>';
				}
				return match;
			});
		}

    function addHtmlSpecialChars(str) {
      return str.replace(/&/g, "&amp;").replace(/>/g, "&gt;").replace(/</g, "&lt;").replace(/"/g, "&quot;");
    }

    function removeHtmlSpecialChars(str) {
      return str.replace(/&amp;/g, "&").replace(/&gt;/g, ">").replace(/&lt;/g, "<&lt;>").replace(/&quot;/g, "\"");
    }

    function validateForm(data) {
      var gotQuery = typeof data.feed != 'undefined' && data.feed.length > 0;

      if (!gotQuery)
        return editor.getLang('extrastrings.invalidFeedNotBlank');    

      return "";
    }

		//add popup
		editor.addCommand('ebay_rss_popup', function(ui, v) {
			//setup defaults
			var content = v.content ? v.content : '';
			var feed = v.feed ? removeHtmlSpecialChars(v.feed) : '';
			var rows = v.rows ? v.rows : '';
			var columns = v.columns ? v.columns : '';
			var slideshow = v.slideshow ? v.slideshow : '';
			var slides = v.slides ? v.slides : '';
			var picwidth = v.picwidth ? v.picwidth : '';
			
			editor.windowManager.open( {
				title: editor.getLang('extrastrings.felRss'),
        //bodyType: 'tabpanel',
				body: [		 
          {
            //title: 'TabPanels',
            type: 'tabpanel',
            items: [
              // Search Criteria Tab Panel
              {
                title: editor.getLang('extrastrings.searchTabTitle'),
                type: 'form',
                items: [
                  {
                    type: 'textbox',
                    name: 'content',
                    label: editor.getLang('extrastrings.resultsTitleLabel'),
                    value: content,
                    tooltip: editor.getLang('extrastrings.resultsTitleToolTip'),
                  },				       
                  {
                    type: 'textbox',
                    name: 'feed',
                    label: editor.getLang('extrastrings.rssLabel'),
                    value: feed,
                    tooltip: editor.getLang('extrastrings.rssToolTip'),
                    minWidth: 300,
                  },
                ]
              },
              // Presentation Tab Panel
              {
                title: editor.getLang('extrastrings.presentationTabTitle'),
                type: 'form',
                items: [             
                  {
                    type: 'textbox',
                    subtype: 'number',
                    name: 'picwidth',
                    label: editor.getLang('extrastrings.picWidthLabel'),
                    value: picwidth,
                    placeholder: fuScriptShortcode.ebayPicWidthList,
                    tooltip: editor.getLang('extrastrings.blankUseDefaults'),
                    maxWidth: 100,
                    maxLength: 4,
                  },	
                  {
                    layout: 'grid',
                    name: 'align',
                    label: editor.getLang('extrastrings.resultsColRowsLabel'),
                    type: 'form',
                    columns: '2',
                    spacingH: 10,
                    spacingV: 0,
                    items: [
                      {
                        type: 'textbox',
                        subtype: 'number',
                        name: 'columns',
                        value: columns,
                        placeholder: fuScriptShortcode.ebayDefColumns,
                        tooltip: editor.getLang('extrastrings.blankUseDefaults'),
                        maxWidth: 100,
                        maxLength: 2,
                      },	
                      {
                        type: 'textbox',
                        subtype: 'number',
                        name: 'rows',
                        value: rows,
                        placeholder: fuScriptShortcode.ebayDefRows,
                        tooltip: editor.getLang('extrastrings.blankUseDefaults'),
                        maxWidth: 100,
                        maxLength: 2,
                      },	
                    ]
                  },							
                  {
                    layout: 'grid',
                    name: 'align',
                    label: editor.getLang('extrastrings.slideShowLabel'),
                    type: 'form',
                    columns: '2',
                    spacingH: 10,
                    spacingV: 0,
                    items: [
                      {
                        type: 'listbox',
                        name: 'slideshow',
                        value: slideshow,
                        'values': [						           
                              {text: editor.getLang('extrastrings.useSettingsDefault'), value: ''},
                              {text: editor.getLang('extrastrings.slideShowNone'), value: 'None'},
                              {text: editor.getLang('extrastrings.slideShowManual'), value: 'Manual'},
                              {text: editor.getLang('extrastrings.slideShowAuto'), value: 'Auto'},
                            ],
                      },						
                      {
                        type: 'textbox',
                        subtype: 'number',
                        name: 'slides',
                        value: slides,
                        placeholder: fuScriptShortcode.ebayDefNumSlides,
                        tooltip: editor.getLang('extrastrings.blankUseDefaults'),
                        maxWidth: 50,
                        maxLength: 2,
                      },	
                    ]
                  },
                ]
              }
            ]
          }
        ],
        onsubmit: function( e ) {

          //check if code valid
          var validationError = validateForm(e.data);    
          if (validationError.length > 0) {
            //if code invalid, display error message and keep text editor window open
            tinyMCE.activeEditor.windowManager.alert(validationError);
            return false;
          }

          var shortcode_str = '[' + sh_tag;
          // check for feed
          if (typeof e.data.feed != 'undefined' && e.data.feed.length)
            shortcode_str += ' feed="' + addHtmlSpecialChars(e.data.feed) + '"';
          // check for rows/columns
          if (typeof e.data.rows != 'undefined' && e.data.rows.length)
            shortcode_str += ' rows="' + e.data.rows + '"';
          if (typeof e.data.columns != 'undefined' && e.data.columns.length)
            shortcode_str += ' columns="' + e.data.columns + '"';
          // check for slides
          if (typeof e.data.slideshow != 'undefined' && e.data.slideshow.length)
            shortcode_str += ' slideshow="'+e.data.slideshow+'"';
          if (typeof e.data.slides != 'undefined' && e.data.slides.length)
            shortcode_str += ' slides="' + e.data.slides + '"';
          // check for picwidth
          if (typeof e.data.picwidth != 'undefined' && e.data.picwidth.length)
            shortcode_str += ' picwidth="' + e.data.picwidth + '"';

          //add panel content
          shortcode_str += ']' + e.data.content + '[/' + sh_tag + ']';
          //insert shortcode to tinymce
          editor.insertContent( shortcode_str);
        }
      });
    });

		//replace from shortcode to an image placeholder
		editor.on('BeforeSetcontent', function(event){ 
			event.content = replaceShortcodes( event.content );
		});

		//replace from image placeholder to shortcode
		editor.on('GetContent', function(event){
			event.content = restoreShortcodes(event.content);
		});

		//open popup on placeholder double click
		editor.on('DblClick',function(e) {
			var cls  = e.target.className.indexOf('wp-' + sh_tag);
			if ( e.target.nodeName == 'IMG' && e.target.className.indexOf('wp-' + sh_tag) > -1 ) {
				var data = e.target.attributes['data-sh-attr'].value;
				var content = e.target.attributes['data-sh-content'].value;
				data = window.decodeURIComponent(data);
				content = window.decodeURIComponent(content);

				editor.execCommand('ebay_rss_popup','',{
					feed : getAttr(data,'feed'),
					rows   : getAttr(data,'rows'),
					columns   : getAttr(data,'columns'),
					slideshow   : getAttr(data,'slideshow'),
					slides   : getAttr(data,'slides'),
					picwidth : getAttr(data,'picwidth'),
					content: content
				});
			}
		});
	});
})();