<?php

require_once __DIR__."/apicall_feedback.php";

//////////////////////////////////////////////////////////////////////////
//
// Handle a feedback search.
//
//////////////////////////////////////////////////////////////////////////
class fuEbayShortcodeFeedback extends fuEbayShortcodeBase
{
	/**
	 * __construct 
	 * class constructor will set the needed filter and action hooks
	 * 
	 * @param array $args 
	 */
	function __construct($args = array()){
	  $this->shortcode_tag = 'ebay_feedback';
	  $this->mce_plugin_url = 'mce/mce-button-feedback.js?v='.FUBABY_EBAY_PLUGIN_VER;
	  parent::__construct();
	}

	/**
	 * shortcode_handler
	 * @param  array  $atts shortcode attributes
	 * @param  string $content shortcode content
	 * @return string
	 */
	function shortcode_handler($atts , $content = null){
		// Attributes
    extract(shortcode_atts(array(
        'seller' => '',
        'limit' => 10,
        'customid' => ''
    ), $atts));
  
    $apicall = new fuEbayFeedbackApiCall($seller);
    $apicall->feedbackLimit = $limit;
    $apicall->customId = $customid;
    return $apicall->call();
	}
}//end class

new fuEbayShortcodeFeedback();
