<?php

require_once __DIR__."/apicall_browse_getitem.php";

//////////////////////////////////////////////////////////////////////////
//
// Handle a single item search.
//
//////////////////////////////////////////////////////////////////////////
class fuEbayShortcodeItem extends fuEbayShortcodeBase
{
	/**
	 * __construct 
	 * class constructor will set the needed filter and action hooks
	 * 
	 * @param array $args 
	 */
	function __construct($args = array()){
	  $this->shortcode_tag = 'ebay_item';
	  $this->mce_plugin_url = 'mce/mce-button-item.js?v='.FUBABY_EBAY_PLUGIN_VER;
	  parent::__construct();
	}

	/**
	 * shortcode_handler
	 * @param  array  $atts shortcode attributes
	 * @param  string $content shortcode content
	 * @return string
	 */
	function shortcode_handler($atts , $content = null){
		// Attributes
    extract(shortcode_atts(array(
        'item' => '',
        'picwidth' => -1,
        'customid' => ''
    ), $atts));
  
    $apicall = new fuEbayBrowseGetItemApiCall($item);
    $apicall->picWidth = $picwidth;
    $apicall->customId = $customid;
    return $apicall->call();
	}
}//end class

new fuEbayShortcodeItem();

//////////////////////////////////////////////////////////////////////////
//
// Handle a single item search.
//
//////////////////////////////////////////////////////////////////////////
class fuEbayShortcodeImage extends fuEbayShortcodeBase
{
  /**
   * __construct
   * class constructor will set the needed filter and action hooks
   *
   * @param array $args
   */
  function __construct($args = array()){
    $this->shortcode_tag = 'ebay_image';
    $this->mce_plugin_url = 'mce/mce-button-image.js?v='.FUBABY_EBAY_PLUGIN_VER;
    parent::__construct();
  }

  /**
   * shortcode_handler
   * @param  array  $atts shortcode attributes
   * @param  string $content shortcode content
   * @return string
   */
  function shortcode_handler($atts , $content = null){
    // Attributes
    extract(shortcode_atts(array(
        'item' => '',
        'picwidth' => -1,
        'customid' => ''
    ), $atts));
  
    $apicall = new fuEbayBrowseGetItemApiCall($item);
    $apicall->picWidth = $picwidth;
    $apicall->customId = $customid;
    $apicall->displayFields = [fuEbayDisplayFields::Image];
    return $apicall->call();
  }
}//end class

new fuEbayShortcodeImage();