<?php # -*- coding: utf-8 -*-

require_once __DIR__ . "/constants.php";

global $ebay_sort_order;
global $fu_ebay_slideshow_styles;
global $fu_buying_options;

$strings = 'tinyMCE.addI18n( "' . _WP_Editors::$mce_locale . '.extrastrings", {
    pluginTitle: "' . FUBABY_EBAY_PLUGIN_TITLE . '",
    dblClicktoEdit: "' . esc_js( __( 'Double-click to edit', 'fast-ebay-listings' ) ) . '",
    felSearch: "' . esc_js( __( 'Fast eBay Search', 'fast-ebay-listings' ) ) . '",
    felSingleItem: "' . esc_js( __( 'Fast eBay Single Item', 'fast-ebay-listings' ) ) . '",
    felSingleImage: "' . esc_js( __( 'Fast eBay Single Image', 'fast-ebay-listings' ) ) . '",
    felRss: "' . esc_js( __( 'Fast eBay RSS Feed', 'fast-ebay-listings' ) ) . '",
    felFeedback: "' . esc_js( __( 'Fast eBay Seller Feedback', 'fast-ebay-listings' ) ) . '",
    itemIdLabel: "' . esc_js( __( 'Item ID', 'fast-ebay-listings' ) ) . '",
    searchTabTitle: "' . esc_js( __( 'Search Criteria', 'fast-ebay-listings' ) ) . '",
    presentationTabTitle: "' . esc_js( __( 'Presentation', 'fast-ebay-listings' ) ) . '",
    epnTabTitle: "' . esc_js( __( 'eBay Partner Network', 'fast-ebay-listings' ) ) . '",
    itemIdToolTip: "' . esc_js( __( 'Enter eBay item ID', 'fast-ebay-listings' ) ) . '",
    picWidthLabel: "' . esc_js( __( 'Picture Width', 'fast-ebay-listings' ) ) . '",
    customIdLabel: "' . esc_js( __( 'Custom ID', 'fast-ebay-listings' ) ) . '",
    customIdToolTip: "' . esc_js( __( 'Used for tracking and reporting', 'fast-ebay-listings' ) ) . '",
    feedbackLimitLabel: "' . esc_js( __( 'Max Feedback Comments', 'fast-ebay-listings' ) ) . '",
    feedbackLimitToolTip: "' . esc_js( __( 'Maximum number of feedback comments to show', 'fast-ebay-listings' ) ) . '",
    resultsTitleLabel: "' . esc_js( __( 'Results Title', 'fast-ebay-listings' ) ) . '",
    resultsTitleToolTip: "' . esc_js( __( 'Title text displayed above results', 'fast-ebay-listings' ) ) . '",
    queryLabel: "' . esc_js( __( 'Search Query', 'fast-ebay-listings' ) ) . '",
    queryToolTip: "' . esc_js( __( 'eBay search query keywords', 'fast-ebay-listings' ) ) . '",
    rssLabel: "' . esc_js( __( 'RSS Feed', 'fast-ebay-listings' ) ) . '",
    rssToolTip: "' . esc_js( __( 'RSS Feed URI (e.g. from RSSGround.com or AuctionRequest)', 'fast-ebay-listings' ) ) . '",
    categoryLabel: "' . esc_js( __( 'Category ID', 'fast-ebay-listings' ) ) . '",
    sellerLabel: "' . esc_js( __( 'Seller', 'fast-ebay-listings' ) ) . '",
    sellerFeedbackToolTip: "' . esc_js( __( 'Seller / User ID to show feedback for', 'fast-ebay-listings' ) ) . '",
    sellerToolTip: "' . esc_js( __( 'Leave blank for default; \'all\' for all; \'author\' for post author', 'fast-ebay-listings' ) ) . '",
    sellerTypeLabel: "' . esc_js( __( 'Seller Type', 'fast-ebay-listings' ) ) . '",
    sellerTypeToolTip: "' . esc_js( __( 'Show results from given seller account types', 'fast-ebay-listings' ) ) . '",
    sellerAny: "' . esc_js( __( 'Any', 'fast-ebay-listings' ) ) . '",
    sellerBusiness: "' . esc_js( __( 'Business', 'fast-ebay-listings' ) ) . '",
    sellerIndividual: "' . esc_js( __( 'Individual', 'fast-ebay-listings' ) ) . '",
    buyingOptionsLabel: "' . esc_js( __( 'Buying Options', 'fast-ebay-listings' ) ) . '",
    buyingOptionsToolTip: "' . esc_js( __( '', 'fast-ebay-listings' ) ) . '",
    buyingOptionsFixedPrice: "' . $fu_buying_options[fuEbayBuyingOptions::FixedPrice] . '",
    buyingOptionsAuction: "' . $fu_buying_options[fuEbayBuyingOptions::Auction] . '",
    buyingOptionsBestOffer: "' . $fu_buying_options[fuEbayBuyingOptions::BestOffer] . '",
    sortingLabel: "' . esc_js( __( 'Sorting', 'fast-ebay-listings' ) ) . '",
    sortingToolTip: "' . esc_js( __( 'Select what sort order results should be presented in', 'fast-ebay-listings' ) ) . '",
    sorting' . fuEbaySortOrder::BestMatch . ': "' . $ebay_sort_order[fuEbaySortOrder::BestMatch] . '",
    sorting' . fuEbaySortOrder::CurrentPriceHighest . ': "' . $ebay_sort_order[fuEbaySortOrder::CurrentPriceHighest] . '",
    sorting' . fuEbaySortOrder::DistanceNearest . ': "' . $ebay_sort_order[fuEbaySortOrder::DistanceNearest] . '",
    sorting' . fuEbaySortOrder::EndTimeSoonest . ': "' . $ebay_sort_order[fuEbaySortOrder::EndTimeSoonest] . '",
    sorting' . fuEbaySortOrder::PricePlusShippingHighest . ': "' . $ebay_sort_order[fuEbaySortOrder::PricePlusShippingHighest] . '",
    sorting' . fuEbaySortOrder::PricePlusShippingLowest . ': "' . $ebay_sort_order[fuEbaySortOrder::PricePlusShippingLowest] . '",
    sorting' . fuEbaySortOrder::StartTimeNewest . ': "' . $ebay_sort_order[fuEbaySortOrder::StartTimeNewest] . '",
    minMaxPriceLabel: "' . esc_js( __( 'Min / Max Price', 'fast-ebay-listings' ) ) . '",
    minMaxPriceToolTip: "' . esc_js( __( 'Leave blank for no filter', 'fast-ebay-listings' ) ) . '",
    resultsColRowsLabel: "' . esc_js( __( 'Results Columns / Rows', 'fast-ebay-listings' ) ) . '",
    slideShowLabel: "' . esc_js( __( 'Slideshow Style / Num Slides', 'fast-ebay-listings' ) ) . '",
    slideShow' . fuEbaySlideShowStyle::None . ': "' . $fu_ebay_slideshow_styles[fuEbaySlideShowStyle::None] . '",
    slideShow' . fuEbaySlideShowStyle::Manual . ': "' . $fu_ebay_slideshow_styles[fuEbaySlideShowStyle::Manual] . '",
    slideShow' . fuEbaySlideShowStyle::Auto . ': "' . $fu_ebay_slideshow_styles[fuEbaySlideShowStyle::Auto] . '",
    useSettingsDefault: "' . esc_js( __( 'Use settings default', 'fast-ebay-listings' ) ) . '",
    blankUseDefaults: "' . esc_js( __( 'Leave blank to use default from settings', 'fast-ebay-listings' ) ) . '",
    invalidQueryCategoryNotBlank: "' . esc_js( __( 'Search query and/or category ID must be specified', 'fast-ebay-listings' ) ) . '",
    invalidMinPriceGreaterThanMax: "' . esc_js( __("Minimum price must be less than maximum price.", "fast-ebay-listings") ) . '",
    invalidFeedNotBlank: "' . esc_js( __( 'RSS Feed URI must be specified', 'fast-ebay-listings' ) ) . '",
  } )';
