<?php

require_once __DIR__."/shortcodes.php";
require_once __DIR__."/apicall_rss.php";


//////////////////////////////////////////////////////////////////////////
//
// Handle an RSS feed of items
//
//////////////////////////////////////////////////////////////////////////
class fuEbayShortcodeRss extends fuEbayShortcodeBase
{
	/**
	 * __construct 
	 * class constructor will set the needed filter and action hooks
	 * 
	 * @param array $args 
	 */
	function __construct($args = array()){
	  $this->shortcode_tag = 'ebay_rss';
	  $this->mce_plugin_url = 'mce/mce-button-rss.js?v='.FUBABY_EBAY_PLUGIN_VER;
	  parent::__construct();
	}

	/**
	 * shortcode_handler
	 * @param  array  $atts shortcode attributes
	 * @param  string $content shortcode content
	 * @return string
	 */
	function shortcode_handler($atts , $content = null){
		// Attributes
    extract(shortcode_atts(array(
        'feed' => '',
        'columns' => -1,
        'rows' => -1,
        'picwidth' => -1,
        'slideshow' => -1,
        'slides' => -1
    ), $atts));
  
    $apicall = new fuEbayRssFeedCall($content);
    $apicall->picWidth = $picwidth;
    $apicall->setTableSize($columns, $rows);
    $apicall->setSlideShow($slideshow, $slides);
    
    $apicall->setFeed($feed);
    return $apicall->call();
	}

}//end class

new fuEbayShortcodeRss();