<?php

require_once __DIR__."/shortcodes.php";
require_once __DIR__."/apicall_browse_search.php";


//////////////////////////////////////////////////////////////////////////
//
// Handle a search of items
//
//////////////////////////////////////////////////////////////////////////
class fuEbayShortcodeSearch extends fuEbayShortcodeBase
{
	/**
	 * __construct 
	 * class constructor will set the needed filter and action hooks
	 * 
	 * @param array $args 
	 */
	function __construct($args = array()){
	  $this->shortcode_tag = 'ebay_search';
	  $this->mce_plugin_url = 'mce/mce-button-search.js?v='.FUBABY_EBAY_PLUGIN_VER;
	  parent::__construct();
	}

	/**
	 * shortcode_handler
	 * @param  array  $atts shortcode attributes
	 * @param  string $content shortcode content
	 * @return string
	 */
	function shortcode_handler($atts , $content = null){
		// Attributes
    extract(shortcode_atts(array(
        'category' => '',
        'query' => '',
        'seller' => '',
        'sellertype' => '',
        'buyingoptions' => '',
        'columns' => -1,
        'rows' => -1,
        'picwidth' => -1,
        'minprice' => -1,
        'maxprice' => -1,
        'aspectname' => "",
        'aspectvalue' => "",
        'sort' => '',
        'customid' => '',
        'slideshow' => -1,
        'slides' => -1
    ), $atts));
  
    $apicall = new fuEbayBrowseSearchApiCall($content);
    $apicall->picWidth = $picwidth;
    $apicall->setTableSize($columns, $rows);
    $apicall->setSlideShow($slideshow, $slides);
    
    $apicall->setQuery($query);
    $apicall->customId = $customid;
    $apicall->setCategories($category);
    $apicall->setSellers($seller);
    $apicall->setSellerType($sellertype);
    $apicall->setBuyingOptions($buyingoptions);
    $apicall->setAspect($aspectname, $aspectvalue);
    $apicall->minPrice = $minprice;
    $apicall->maxPrice = $maxprice;
    $apicall->setSortOrder($sort);
    return $apicall->call();
	}

}//end class

new fuEbayShortcodeSearch();